//
// Created by daniel on 23.7.20.
//

#include "config.h"

Config::Config()
:m_Max(0)
{
}

bool Config::Load(const std::string & fileName)
{
    std::ifstream input(fileName);

    if (!input.is_open())
        return false;

    if (!input.good()) {
        input.close();
        return false;
    }

    std::string line, word;
    while( getline(input, line) )
    {
        replace(line.begin(), line.end(), '\n', ' ');
        replace(line.begin(), line.end(), '\t', ' ');

        ScanChain scanChain;
        std::istringstream iline(line);

        while ( getline(iline, word, ' ') )
            if (word != "")
                scanChain.AddCell(word);
        m_ScanChains.push_back(scanChain);

        if (scanChain.GetScanCells().size() > m_Max)
            m_Max = scanChain.GetScanCells().size();
    }
    return true;
}

size_t Config::GetMax() const {
    return m_Max;
}

std::vector<ScanChain> Config::GetScanChains() const {
    return m_ScanChains;
}


std::ostream & operator << (std::ostream &os, const Config & config) {
    for(auto const & sc : config.m_ScanChains)
        os << sc << "\n";
    return os;
}
