//
// Created by Admin on 7/14/2020.
//

#ifndef PROGRAM_GENERATOR_H
#define PROGRAM_GENERATOR_H

#include <iostream>
#include <algorithm>
#include <cmath>


#include "config.h"
#include "../../structure/model.h"



class Generator {
public:
    enum ScanChainsGenerateMode {
        SCANCHAIN_SIZE = 0,
        SCANCHAIN_NUMBER,
        SCANCHAIN_UNDEFINED,
        SCANCHAIN_RANDOM
    };

    Generator();
    void GenerateIllinois(const Model * model, const std::string &configFile, std::ostream &output) const;
    void GenerateConfig(const std::vector<Command*> &inputs, std::ostream & os, size_t number, ScanChainsGenerateMode mode) const;
    void GenerateIllinoisTest(const Model * model, const std::string &configFile, std::ostream &output) const;
    void GenerateCombinationalLogic(const Model * model, const std::string & fileName) const;

    static bool CheckFile(std::ofstream & file);

private:
    void GenerateScanChain(std::ostream & output, const ScanChain & scanChain) const;
    void GenerateNames(const Model *model, std::ostream & output) const;
    static int Randomize(int i);

};


#endif //PROGRAM_GENERATOR_H
