//
// Created by daniel on 21.5.20.
//

#ifndef PROGRAM_EXDC_H
#define PROGRAM_EXDC_H

/*
 * --------------------------------------------
 * Blif file - External Don't Care
 * --------------------------------------------
 *
 * External don’t cares are specified as a separate network within a model, and are specified at the end of the model
 * specification. Each external don’t care function, which is specified by a .names construct, must be associated
 * with a primary output of the main model and specified as a function of the primary inputs of the main model
 * (hierarchical specification of external don’t cares is currently not supported).
 *
 * The external don’t cares are specified as follows:
 *
 * .exdc
 * .names <in-1> <in-2> ... <in-n> <output>
 * <single-output-cover>
 *
 * _exdc indicates that the following .names constructs apply to the external don’t care network.
 * output is a string giving the name of the primary output for which the conditions are don’t cares.
 * in-1, in-2, ... in-n are strings giving the names of the primary inputs which the don’t care conditions are expressed
 * in terms of.
 *
 * single-output-cover is an n-input, 1-output PLA description of the logic function corresponding to the don’t care
 * conditions for the output.
 *
 * The following is an example circuit with external don’t cares:
 *
 * .model a
 * .inputs x y
 * .outputs j
 * .subckt b x=x y=y j=j
 * .exdc
 * .names x j
 * 1 1
 * .end
 *
 * .model b
 * .inputs x y
 * .outputs j
 * .names x y j
 * 11 1
 * .end
 *
 * The translation of the above example into a sum-of-products notation would be as follows:
 * j = x * y;
 * external d.c. for j = x;
 *
 */

class Exdc {
public:

private:
};

#endif //PROGRAM_EXDC_H
