
#include <iostream>
#include "iloader/iloader.h"

int Error(const std::string & message)
{
    std::cout << message << std::endl;
    return 1;
}



int main(int argc, char * argv[])
{
    ILoader loader(argc, argv);

    if ( !loader.SetInput() )
        return Error("Setting input file fails.");

    if ( !loader.SetParam() )
        return Error("Setting scan-chains fails.");

    if ( !loader.SetOutput() )
        return Error("Setting output fails.");

    if ( !loader.Generate() )
        return Error("Setting config generation fails.");

    return 0;
}
